           #INCLUDE <P18F252.INC>  ; 
	ORG     0
        GOTO    R0
R0
 MOVLB  15 	        ;  15.
 CLRF   PORTA           ;
 CLRF   LATA            ;
 CLRF   ADCON1          ;  ,   ADRESH
 MOVLW  B'01111111'     ;   
 MOVWF	TRISA     	;
 CLRF   PORTB           ;
 CLRF   LATB            ;
 MOVLW  B'00000000'     ;   
 MOVWF	TRISB     	;
 CLRF   PORTC           ;
 CLRF   LATC            ;
 MOVLW  B'00000000'     ;   
 MOVWF	TRISC           ;
 CLRF   PIE1            ;  
 CLRF   PIE2            ;
 MOVLW  B'00010011'     ;
 MOVWF	RCON            ; 
 CLRF   INTCON          ; 
 CLRF   INTCON3         ; 
 MOVLW  B'11111111'     ;  .
 MOVWF  INTCON2         ;
 CLRF   RCSTA           ; USART .
 CLRF   CCP2CON         ; CCP2 .
 CLRF   CCP1CON         ; CCP1 .
 CLRF   SSPCON1         ; 2MSSP .
 CLRF   SSPCON2         ; 1MSSP .
 CLRF   T0CON           ; TMR0 .
 CLRF   T1CON           ; TMR1 .
 CLRF   T2CON           ; TMR2 .
 CLRF   WDTCON          ;WDT .
 CLRF   OSCCON          ;T     
 MOVLW	B'00000001'     ; ,-ADRESH,-A0.
 MOVWF	ADCON0	        ; .
movlw	B'00000110'     ; , 
movwf	ADCON1		;  
 MOVLB  0 	        ;  0.
WID      EQU  H'00'     ;  ,  
WREM     EQU  H'01'     ;    WREM
MOVLW  .1               ;1  WID./   /
MOVWF  WID              ;
MOVLW   B'00000001'     ;  
MOVWF   PORTC           ;
 MOVLB  1 	        ;  1
WREM1    EQU  H'100'    ;  FF  WREM1

R1                          ; 
        BTFSS   PORTA,1     ;
        GOTO    UW          ; 
        BTFSS   PORTA,2     ;
        GOTO    UM          ; 
        GOTO    R2          ;
UW
        CALL    T1          ;
        CALL    T1
        CALL    T1
        CALL    T1
        CALL    T1
        CALL    T1
        CALL    T1
        INCF    WID,1       ;
	MOVF	WID,0
        SUBLW   0X09        ;
	BTFSS	STATUS,2    ;
	GOTO	WD0
        MOVLW   .9          ;
        MOVWF   WID         ;
UM
        CALL    T1          ;
        CALL    T1
        CALL    T1
        CALL    T1
        CALL    T1
        CALL    T1
        CALL    T1
        DECF    WID,1       ; 
	BTFSS	STATUS,2    ; 
        GOTO 	WD0         ;
        MOVLW   .1          ;
        MOVWF   WID         ;
        GOTO    R1 

WD0	                    ; 
	MOVF	WID,0
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	WID1        ; 
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	WID2        ; 
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	WID3        ; 
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	WID4        ; 
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	WID5        ; 
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	WID6        ; 
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	WID7        ; 
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	WID8        ; 

WID1
        MOVLW   B'00000001' ;
        MOVWF   PORTC       ;
        MOVLW   0X10        ;  
        MOVWF   WREM        ;
	GOTO	R1
WID2
        MOVLW   B'00000010' ;
        MOVWF   PORTC       ;
        MOVLW   0X20        ;  
        MOVWF   WREM        ;
	GOTO	R1
WID3
        MOVLW   B'00000100' ;
        MOVWF   PORTC       ;
        MOVLW   0X30        ;  
        MOVWF   WREM        ;
	GOTO	R1
WID4
        MOVLW   B'00001000' ;
        MOVWF   PORTC       ;
        MOVLW   0X40        ;  
        MOVWF   WREM        ;
	GOTO	R1
WID5
        MOVLW   B'00010000' ;
        MOVWF   PORTC       ;
        MOVLW   0X50        ;  
        MOVWF   WREM        ;
	GOTO	R1
WID6
        MOVLW   B'00100000' ;
        MOVWF   PORTC       ;
        MOVLW   0X60        ;  
        MOVWF   WREM        ;
	GOTO	R1
WID7
        MOVLW   B'01000000' ;
        MOVWF   PORTC       ;
        MOVLW   0X70        ;  
        MOVWF   WREM        ;
	GOTO	R1
WID8
        MOVLW   B'10000000' ;
        MOVWF   PORTC       ;
        MOVLW   0X80        ;  
        MOVWF   WREM        ;
	GOTO	R1

R2                          ; 
 MOVLB  0 	            ;
 MOVLW  B'00000000'         ; 
 MOVWF  FSR1H               ;
        MOVLW   0X02        ; 
        MOVWF   FSR1L       ;
 MOVLB  1 	            ; 
 MOVLW  B'00000001'         ; 
 MOVWF  FSR2H               ;
        MOVLW   0X02        ; 
        MOVWF   FSR2L       ;
R3
 MOVLB  0 	            ; 
        CALL    AZP0        ;
        MOVF    ADRESH,0    ;
        MOVWF   INDF1       ;
        INCF    FSR1L       ;
 MOVLB  1 	            ; 
        MOVF    INDF2,0     ;       
        MOVWF   PORTB       ;
        INCFSZ  FSR2L       ; 
        GOTO    R3          ; 
 MOVLB  2 	            ; 
 MOVLW  B'00000010'     ;
 MOVWF  FSR1H           ;
        MOVLW   0X02        ; 
        MOVWF   FSR1L       ;
 MOVLB  3 	            ; 
 MOVLW  B'00000011'         ;
 MOVWF  FSR2H               ;
        MOVLW   0X02        ; 
        MOVWF   FSR2L       ;
R4
 MOVLB  2 	            ; 
        CALL    AZP2        ;
        MOVF    ADRESH,0    ;
        MOVWF   INDF1       ;
        INCF    FSR1L       ; 
 MOVLB  3 	            ; 
        MOVF    INDF2,0     ;      
        MOVWF   PORTB       ;
        INCFSZ  FSR2L       ; 
        GOTO    R4          ; 
 MOVLB  0 	            ; 
 MOVLW  B'00000000'     ;
 MOVWF  FSR1H           ;
        MOVLW   0X02        ; 
        MOVWF   FSR1L       ;
 MOVLB  1 	            ; 
 MOVLW  B'00000001'     ;
 MOVWF  FSR2H           ;
        MOVLW   0X02        ; 
        MOVWF   FSR2L       ;
R5
 MOVLB  1 	            ; 
        CALL    AZP1        ;
        MOVF    ADRESH,0    ;
        MOVWF   INDF2       ;
        INCF    FSR2L       ;
 MOVLB  1 	            ; 
        MOVF    INDF1,0     ;      
        MOVWF   PORTB       ;
        INCFSZ  FSR1L       ; 
        GOTO    R5          ; 
 MOVLB  2 	            ; 
 MOVLW  B'00000010'     ;
 MOVWF  FSR1H           ;
        MOVLW   0X02        ; 
        MOVWF   FSR1L       ;
 MOVLB  3 	            ; 
 MOVLW  B'00000011'     ;
 MOVWF  FSR2H           ;
        MOVLW   0X02        ; 
        MOVWF   FSR2L       ;
R6
 MOVLB  3 	            ; 
        CALL    AZP3        ;
        MOVF    ADRESH,0    ;
        MOVWF   INDF2       ;
        INCF    FSR2L       ;
 MOVLB  2 	            ; 
        MOVF    INDF1,0     ;    
        MOVWF   PORTB       ;
        INCFSZ  FSR1L       ; 
        GOTO    R6          ; 
        GOTO    R1          ;
AZP0
        BSF	ADCON0,2    ;
	CALL	T	    ;
        BCF     ADCON0,2    ;
        MOVF	ADRESH,0    ;
        RETURN
AZP1
        BSF	ADCON0,2    ;
	CALL	T	    ;
        BCF     ADCON0,2    ;
        MOVF	ADRESH,0    ;
        RETURN 
AZP2
        BSF	ADCON0,2    ;
	CALL	T	    ;
        BCF     ADCON0,2    ;
        MOVF	ADRESH,0    ;
        RETURN
AZP3
        BSF	ADCON0,2    ;
	CALL	T	    ;
        BCF     ADCON0,2    ;
        MOVF	ADRESH,0    ;
        RETURN
T1
	MOVLW	0XFF
        MOVWF   WREM1
T2
        CALL    T3          ;
	DECFSZ  WREM1,1	
        GOTO	T2	    ;
	RETURN
T3
	MOVLW	0XFF	    ;
T4
	ADDLW	-1	    ;
	BTFSS	STATUS,2    ;
	GOTO	T4	    ;
	RETURN 
T
	MOVF	WREM,0
T5
	ADDLW	-1	    ;
	BTFSS	STATUS,2    ;
	GOTO	T5	    ;
	RETURN
; Configuration bytes settings
	ORG 0x300000
	DW 0x2600
	DW 0x000D
	DW 0x0000
	DW 0x0080
	DW 0xFFFF
	DW 0xFFFF
	DW 0xFFFF
   END
